/****************************************************************************
** fileNameFuntions.cpp
**
** implementation of file name functions and tests (for sprtalay) 
**
** Created: Sat Okt 04 11:37:49 2003
** 
** by Karsten Hiller 
** 
****************************************************************************/
#include <StdAfx.h>

/*****************************************************************************
** FilePathComp komprimiert die Lnge des FilePfades fr die Statusanzeige
** char* filepathcomp - Zeiger auf den komprimierten FilePfadNamen
** char* filepath - Zeiger auf gesamten FilePfadNamen
** ushort complen - maximal erwnschte Lnge des FilePfadNamens
** Der Rckgabewert ist der Zeiger auf den komprimierten FilePfadNamen
*****************************************************************************/
char* FilePathComp( char* filepathcomp, char* filepath, ushort complen)
{
  char bufferP[4]			= "\0";	//Puffer fr Abkrzungspunkte
  char bufferA[4]			= "\0";	//Puffer fr LW Buchstaben
  char bufferB[_MAX_FNAME] = "\0";	//Puffer fr Zwischenspeicherung
  char bufferC[_MAX_FNAME] = "\0";	//Puffer fr TeilPath
  char bufferD[_MAX_FNAME] = "\0";	//Puffer fr Dateinamen
  char* pA = NULL;					//Zeiger auf LW-NamenAnfang
  char* pB = NULL;					//Zeiger 
  char* pC = NULL;					//Zeiger auf TeilPathAnfang
  char* pD = NULL;					//Zeiger auf DateiNamenAnfang
  ulong ulP = 0;					//Lnge der Abkrzungspunkte 
  ulong ulA = 0;					//Lnge des LW
  ulong ulB = 0;					//Lnge des TeilPaths
  ulong ulC = 0;					//Lnge des TeilPaths aktuell (gltig)
  ulong ulD = 0;					//Lnge des Dateinamens
  ulong len = 0;					//Lnge des FilePaths
  ulong i = 0;						//Zhl-Variable

  len = strlen( filepath );
  if( complen > len )				  //passt der FilePathName ganz rein
  {									  //JA
	strcpy( filepathcomp, filepath ); //dann kopiere ihn einfach
  }
  else								  //NEIN
  {
    ulP = 3;						  //Lnge Punkte merken
	if( ulP > complen )				  //sind Lnge von 3 Punkten grsser als Lnge
	{								  //JA
	  ulP = 0;						  //keine Punkte
	  strcpy( bufferP, "..." );		  //Punkte einfgen, werden am Ende mit Hilfe von
	}								  //strncpy(filepathcomp,bufferB,complen) abgeschnitten
	else
	{								  //NEIN
	  strcpy( bufferP, "..." );		  //Punkte einfgen
	  // Laufwerksbuchstaben ermitteln
  	  if( filepath[1] == ':' )		  //ist der erste Name ein LW
	  {								  //JA
		ulA = 3;					  //LW-Lnge merken
		if( ulA+ulP > complen )		  //ist LW+Punkte grsser als Lnge
		{							  //JA
		  ulA = 0;
		  strcpy( bufferA, "" );	  //keine LW-Angabe wegen Platz mglich
		}
		else
		{
		  pA = filepath;			  //Zeiger auf LW-Anfang
		  strncpy( bufferA, pA, ulA );//LW-Name merken
		}
	  }
	  else
	  {								  //NEIN
		ulA = 0;
		strcpy( bufferA, "\0" );	  //kein LW-Angabe vorhanden
	  }
	  //Dateiname ermitteln
	  for( i = len; i >= 0; --i )		  //Dateiname ermitteln
	  {
		if( filepath[i] == '\\' )		  //Namenanfang erreicht
		{
		  pD = filepath+len-ulD;		  //Zeiger auf Dateinameanfang inc. '\'
		  strncpy( bufferD, pD, ulD );	  //DateiName merken
		  break;
		}
		++ulD;							  //Zhler Lnge Dateiname erhhen
	  }
	  //berprfungen
	  if( ulA+ulP+ulD > complen )		  //ist LW+Punkte+Dateiname grsser als Lnge
	  {									  //JA
		ulD = complen-ulA-ulP;			  //max. zulssige Lnge des Dateinamens ermitteln
		pD = filepath+len-ulD;			  //Zeiger auf Anfang des ab zuschneidenden Namens
		strncpy( bufferD, pD, ulD );	  //Dateiname vorn abschneiden
	  }
	  else
	  {									  //NEIN
		//Teil Paths ermitteln
		for( i = len-ulD; i > ulA; --i)   //PathNamenTeile ermitteln
		{
		  if( filepath[i] == '\\' )		  //Teil des PathNamenAnfangs erreicht
		  {
			if( ulA+ulP+ulB+ulD > complen)//ist LW+Punkte+TeilPath+Dateiname grsser als Lnge
			{							  //JA
			  break;					  //Schleife abbrechen
			}
			else
			{							  //NEIN
			  ulC = ulB;				  //Zhler TeilPath+1 und Ergebis merken
			  pC = filepath+len-ulD-ulC;  //Zeiger auf Anfang des TeilPathes
			  strncpy( bufferC, pC, ulC); //TeilPath kopieren
			}
		  }
		  ++ulB;						  //Zhler Lnge TeilPath erhhen
		}
	  }
	}
	//zusammenstellen des gekrzten FilePfadNamens
	sprintf( bufferB, "%s%s%s%s", bufferA, bufferP, bufferC, bufferD );
	//zur Sicherheit bei sehr kurzen Lngen <3 (Punkte einfach abschneiden)
	strncpy( filepathcomp, bufferB, complen );
/*
	sprintf( bufferB, "LW   : %s \n"
					  "Pfad : %s \n"
					  "Datei: %s \n"
					  "Comp : %s \n"
					  "Lnge: %i", 
					  bufferA, bufferC, bufferD, filepathcomp, strlen(filepathcomp) );
	MessageBox(NULL, bufferB, "Test Info FilePathComp", MB_ICONINFORMATION | MB_OK );
*/  
  }		   
  return( filepathcomp );
}

/*****************************************************************************
** IsWinASCII prft ob das bergebene Zeichen ein gltiges Sonderzeichen fr  
** einen Filenamen ist. 
** erlaubte Sonderzeichen in DOS: $% '-_@~`!(){}^#&	 in WIN: +,;=[]
** Der Returnwert ist 0, wenn es ein gltiges Sonderzeichen ist es der Wert 
** des Zeichens
*****************************************************************************/
int IsWinASCII( char zeichen )
{
  const uchar WIN_ASCII[] = {32,33,35,36,37,38,39,40,41,43,44,45,59,61,64,91,93,94,95,96,
						    123,125,126,129,132,142,148,153,154};
  int test = 0;

  for( short i = 0; i <= sizeof( WIN_ASCII ); i++)
  {
    if( (uchar)zeichen == WIN_ASCII[i] ) //prft ob eines der zulssigen Zeichen enthalten ist
    {
	  test = WIN_ASCII[i];
	  break;
	}
  }
  return( test );
}

/*****************************************************************************
** MakeValidFileName ersetzt in den bergeben Filenamen ggf. ungltige Zeichen
** durch einen Bindestrich '-'
** erlaubte Zeichen in DOS: a-z A-Z 0-9 $% '-_@~`!(){}^#&	WIN: +,;=[]
** validFileName - Zeiger auf korregierten Filenamen
** fileName - Zeiger auf den zu prfenden Filenamen
** Der Rckgabewert ist der Zeiger auf den korregierten Filenamen
*****************************************************************************/
char* MakeValidFileName( char* validFileName, uchar* fileName )
{
  char buffer[_MAX_FNAME] = "\0";
  ulong i = 0;

  sprintf( validFileName, "%s\0", fileName);
  for( i = 0; i < strlen( validFileName ); i++ )//alle Zeichen prfen, LW ggf berspringen
  {
	if( (0 == isalnum( validFileName[i] )) && (0 == IsWinASCII( validFileName[i] )) )
	{
	  validFileName[i] = '-';					//ersetzt ungltiges Zeichen
	}
  }
  return( validFileName );
}


