/****************************************************************************
** lg_error.cpp	
**
** implementation of Error Messages Dialogs by MegaCAD LG_xxx Functions
**
** Created: Mon Sep 29 22:18:00 2003
** 
** by K. Hiller 
** 
****************************************************************************/
#include <StdAfx.h>

#define MT_MAX 255 //maximale Anzahl von Zeichen in mt 

/****************************************************************************
** LG_Error erzeugt eine Windows Messagebox in der die Fehlernummer der
** LG_xxx Funktion von den MegaCAD Layerfunktionen und eine Textbeschreibung
** des Fehlers ausgegeben wird.
** name - Zeiger auf den Name des Messagebox 
**		  (z.B. Name der Funktion welche den Fehler erzeugte) 
** *err - Zeiger auf die Nummer Fehlermeldung, welche durch die LG_xxx
**		  Funktion zurckgegeben wurde
** Der Rckgabewert gibt den Wert des Button der Messagebox zurck s. WinAPI		  
****************************************************************************/
int LG_Error(char *name, ushort *err)
{
	int ret = 0;			//Variable fr MessageBoxButton Rckgabewert
	char mt[MT_MAX] = "\0";	//Variable fr Fehlermeldungstext
	if (*err != 0)			//Fehler berhaupt da?
	{
		switch (*err)	//Verzweigung zu den definierten Fehlermeldungen
		{
			case LGERR_INVALIDLIST	: strcpy( mt, "Eine ungltige Liste wurde bergeben." ); 
									  break;
			case LGERR_INVALIDITEM	: strcpy( mt, "Ein ungltiges Item wurde bergeben." ); 
									  break;
			case LGERR_DATANEEDED	: strcpy( mt, "Es fehlen Daten um eine gltige Liste oder Item zu erzeugen." ); 
									  break;
			case LGERR_NUMTWICE		: strcpy( mt, "In der Liste wurde eine doppelte Itemnummer gefunden." ); 
									  break;
			case LGERR_MEMORY		: strcpy( mt, "Nicht genug Speicher um eine Liste oder Item zu erzeugen." ); 
									  break;
			case LGERR_RECURSIVE	: strcpy( mt, "Eine Rekursion ist in der Liste aufgetreten." ); 
									  break;
			case LGERR_MAXLEVEL		: strcpy( mt, "Die maximale Anzal der Subitems (>254) wurde berschritten." ); 
									  break;
			case LGERR_OPCODE		: strcpy( mt, "Fehlerhafter OP-Code. " ); 
									  break;
			case LGERR_ROOTNEXT		: strcpy( mt, "ROOTNEXT, kein Item mehr???" ); 
									  break;
			default					: strcpy( mt, "Undocumentierter Fehlercode." ); 
									  break;
		}
		sprintf( mt, "%s \nFehlernummer: %n", mt, *err );
		ret = MessageBox( NULL, mt, name, MB_ICONERROR | MB_ABORTRETRYIGNORE | MB_DEFBUTTON2 );
	}
	return( ret );
}


